#include <stdio.h>
#include <stdarg.h>
#include <iostream>
#include <fstream>

#include <time.h>
#include <sys\timeb.h>
#include "Log.h"

#include <SysUtils.hpp>

CLog::CLog()
{
	sFile = "";
	iLogLevel = 0;
	callbackLog = NULL;
};

int CLog::SetFile(std::string file)
{
	sFile = file;
	iLogLevel = E_LOG_NONE;
	if (file != "")
	{
		FILE *fout = fopen(sFile.c_str(),"at+");
		fclose(fout);
		if (fout == NULL)
		{
			return -1;
		}
	}
	return 0;
}

void CLog::SetLevel(int level)
{
	iLogLevel = level;
}

void CLog::log(char *lpData, ...)
{
	//if (level > iLogLevel)
	//	return;
	FILE* fout;
	va_list ap;
	static char buf[1024]; //determines max message length
/*
	struct timeb timebuffer;
	char *timeline;
	ftime( &timebuffer );
	timeline = ctime( & ( timebuffer.time ) );
    timeline[19]=0;
	int size = sprintf(buf, "%15s.%03hu  ", &timeline[4], timebuffer.millitm);
*/
    // more CG friendly:
    int size = sprintf(buf, "%s  ", FormatDateTime("yyyy-mm-dd hh:mm:ss.zzz", Now()).c_str());

	va_start(ap, lpData);
	size += vsnprintf(buf + size, sizeof(buf)-size-2, lpData, ap);
	va_end(ap);
	buf[size] = '\n';
	buf[size+1] = 0;

	if (sFile != "")
	{
		fout = fopen(sFile.c_str(),"at+");
		fprintf(fout, buf);
		fclose(fout);
	}
	buf[size] = '\0';   // usu koncowy \n
	if (callbackLog)
		callbackLog(buf);
}

